﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file elServicePro.py
 @brief ModuleDescription
 @date $Date$


"""
import sys
import time
import RPi.GPIO as GPIO
import serial
import math
import datetime
import smtplib
import requests
import time
import urllib3
import urllib
import socket
import threading
import os
import numpy as np
import httplib
from email.mime.text import MIMEText
from twilio.rest import Client
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist

import elService_idl

try:
    import httplib
except:
    import http.client as httplib

GPIO_WATCHDOG = 16
GPIO_NETERROR = 18

GPIO.setwarnings(False)
GPIO.setmode(GPIO.BOARD)
GPIO.setup(GPIO_WATCHDOG, GPIO.OUT)
GPIO.setup(GPIO_NETERROR, GPIO.OUT)

GPIO.output(GPIO_WATCHDOG, GPIO.LOW)
GPIO.output(GPIO_NETERROR, GPIO.LOW)

ser = serial.Serial("/dev/ttyS0")
ser.baudrate = 115200
ser.timeout = 0.05

#networkOK = False
networkOK = False
sendingFlag = False
checkNetworkCnt = 1

SERVERIP = ""
SERVERURL = ""
SMTP = ""
SMTPPORT = ""
USER = ""
PASS = ""
FROM = ""
TO1 = ""
TO2 = ""
TO3 = ""
TO4 = ""
TO5 = ""
#INIFILE = "/var/www/html/configset.ini"
INIFILE = "./configset.ini"
ADCTEMP = "adcdata.csv"

ERRORLOG = "errorlog.csv"
ADTHRESHOLD = 0xf000

# Channel 1 analog
# Channel 2 analog
# Channel 3 Full water alert
# Channel 4 blackout alert
# Channel 5 Level sensor
LIQUIDDENSITY = 1.7
CH5_A=1.7
CH5_B=-1.7
CH5MAX = 6.8

CH6_A=1.7
CH6_B=-1.7
CH6MAX = 6.8

CH7_A=1.7
CH7_B=-1.7
CH7MAX = 6.8

CH4STR = "Blackout"
CH3STR = "Full water"
account_sid = "AC1fd3f7ceab8d4d6d68a087b18aa941d3"
auth_token = "05168a8bc5dc82cada06562f7f0746dd"
client = Client(account_sid, auth_token)
#client2 = Client(account_sid, auth_token)

# Read Config File -----------------------------------------
def readConfigFile():
    global SERVERIP
    global SERVERURL
    global SMTP
    global SMTPPORT
    global USER
    global PASS
    global FROM
    global TO1
    global TO2
    global TO3
    global TO4
    global TO5
    global TO6
    global TO7
    global TO8
    global ADCFILE

    fcfgH = open(INIFILE, "r")
    for line in fcfgH:
        dataArray = line.split(':')
        dataCont = dataArray[1].replace('\n', '')
        if dataArray[0] == "0":     # Server IP, Domain
            SERVERIP = dataCont
        elif dataArray[0] == "1":   # Server file, program
            SERVERURL = "http://" + SERVERIP + "/" + dataCont
        elif dataArray[0] == "2":   # SMTP
            SMTP = dataCont
        elif dataArray[0] == "3":   # SMTPPORT
            SMTPPORT = dataCont
        elif dataArray[0] == "4":   # USER
            USER = dataCont
        elif dataArray[0] == "5":   # PASS
            PASS = dataCont
        elif dataArray[0] == "6":   # FROM
            FROM = dataCont
        elif dataArray[0] == "7":   # TO1
            TO1 = dataCont
        elif dataArray[0] == "8":   # T02
            TO2 = dataCont
        elif dataArray[0] == "9":   # T03
            TO3 = dataCont
        elif dataArray[0] == "A":   # TO4
            TO4 = dataCont
        elif dataArray[0] == "B":   # T05
            TO5 = dataCont
        elif dataArray[0] == "C":   # T06
            TO6 = dataCont
        elif dataArray[0] == "D":   # T07
            TO7 = dataCont
        elif dataArray[0] == "E":   # T08
            TO8 = dataCont
    fcfgH.close()

# Send remain files ----------------------------------------
def sendFile():
    sucFlag = False
    try:
        # Check if exist data on file
        existF = os.stat(ADCTEMP)
        if existF.st_size > 0:
            fileD = open(ADCTEMP, 'r')
            dataF = fileD.read()
            fileD.close()
            dataFArray = dataF.split("\x1b")
            for ldataF in dataFArray:
                if len(ldataF) != 0:
                    resp = 200
                    if(resp == 200):
                        sucFlag = True
                        print("Block sended!")
                    else:
                        sucFlag = False
                        print("File sended failed!")
    except:
        print("File open error or network failed!")

    if sucFlag == True:
        lf = open(ADCTEMP, 'w')
        lf.write("")
        lf.close()


# Read from serial -----------------------------------------
def readSerialLine():
    global checkNetworkCnt
    rx = ""
    while True:
        if(GPIO.input(GPIO_WATCHDOG) == GPIO.LOW):
            GPIO.output(GPIO_WATCHDOG, GPIO.HIGH)
        else:
            GPIO.output(GPIO_WATCHDOG, GPIO.LOW)

        checkNetworkCnt = checkNetworkCnt - 1
     #   if checkNetworkCnt == 0:
     #      checkNetwork()
     #       checkNetworkCnt = 400

        try:
            car = ser.read()
            #print(type(car))
            rx += car.decode('utf-8')
            #print("rx :"+rx)
            if (car == b'\n'):
                return rx
            elif (car == b'\x1a'):
                return "Z"
        except serial.SerialException:
            #print("erx :"+rx)
            print("Serial Error!")

# Convert to float with sign 8 bits ------------------------
def convToFloat8(inVal):
    outVal = float.fromhex(inVal)
    if(int(inVal, 16) & 0x80):
        outVal = 0xff - outVal + 1
        outVal*= -1
    return outVal

# Convert to float with sign 16 bits -----------------------
def convToFloat16(inVal):
    outVal = float.fromhex(inVal)
    if(int(inVal, 16) & 0x8000):
        outVal = 0xffff - outVal + 1
        outVal *= -1
    return outVal

# Make keys strings ========================================
def keys(**args):
    return args

# Make channel string to send ==============================
# Not used !!!
def makeChannelString(strin, chNum):
    chArray = np.array(['ch0','ch1','ch2','ch3'])

    strin = strin + chArray[chNum] + ' '

    return strin

# Send data to server ======================================
def sendToServer(strData):
    global sendingFlag

    strChName = np.array(['ch0','ch1','ch2','ch3','ch4','ch5','ch6','ch7','ch8','ch9','ch10',
                          'ch11','ch12','ch13','ch14','ch15','ch16','ch17','ch18','ch19','ch20',
                          'ch21','ch22','ch23','ch24','ch25','ch26','ch27','ch28','ch29','ch30',
                          'ch31','ch32'])
    strChVal  = np.array(['NA    ','NA    ','NA    ','NA    ','NA    ',
                          'NA    ','NA    ','NA    ','NA    ','NA    ',
                          'NA    ','NA    ','NA    ','NA    ','NA    ',
                          'NA    ','NA    ','NA    ','NA    ','NA    ',
                          'NA    ','NA    ','NA    ','NA    ','NA    ',
                          'NA    ','NA    ','NA    ','NA    ','NA    ',
                          'NA    ','NA    ','NA    '])

    sendingFlag = True

    data2Str = ''
    dateStr = ''
    timeStr = ''

    try:
        bufArray = strData.split("\n")
        if bufArray != "":
            # Get each line's voltage end fill the array
            for lbuf in bufArray:
                if lbuf != "":
                    strArray = lbuf.split(',')
                    strChVal[int(strArray[1])] = strArray[3]    # Get voltage
                    data2Str = strArray[0]
                    dateStr = strArray[4]
                    timeStr = strArray[5]

            # Mount buffer
            strChannel = ''
            for cnt in range(33):
                if cnt != 0:
                    strChannel += strChName[cnt] + " " + strChVal[cnt].strip()
                    if cnt < 32:
                        strChannel += ','

            #print (strChannel)

            # Set parameters to be sent
            par = keys(mode = 'd',
                        sid = data2Str,
                        date = dateStr,
                        time = timeStr,
                        data1 = strChannel,
                        data2 = ''
                       )

            resp = requests.post(SERVERURL, params=par)
            print(resp.url)
            '''
                    par = keys(idNum = strArray[0],
                                channel = strArray[1],
                                mode = strArray[2],
                                volts = strArray[3],
                                date = strArray[4],
                                time = strArray[5]
                               )
                resp = requests.post(SERVERURL, params=par)
            '''
        print(resp.status_code)

        GPIO.output(GPIO_NETERROR, GPIO.HIGH)
        sendingFlag = False
        return resp.status_code
    except Exception as err:
        GPIO.output(GPIO_NETERROR, GPIO.LOW)
        sendingFlag = False
        return 0

# Timer interrupt ==========================================
def checkNetwork():
    global sendingFlag
    global networkOK
    global tNetCheck
    global THRTIMER

    tNetCheck = threading.Timer(THRTIMER, checkNetwork)
    tNetCheck.start()
    #networkOK = True
    if sendingFlag == False:
        try:
            #conn = httplib.HTTPConnection(SERVERIP, timeout=5)
            conn = httplib.HTTPConnection("ellighttracker2.appspot.com", timeout=5)
            conn.request("HEAD", "/")
            conn.close()
            networkOK = True
            GPIO.output(GPIO_NETERROR, GPIO.HIGH)
            sendFile()
            print("Network OK")
        except:
           # conn.close()
            networkOK = False
            GPIO.output(GPIO_NETERROR, GPIO.LOW)
            print("test net")
            print("Network error")


# Process ==================================================
# Serial format
'''
  D<ID>,<CHANNEL>,<ADC>,<DIG/ANA>,<ADCMAX>,<ADCMAXEXP>,<ADJ>,<ADJEXP><CR><LF>
'''

readConfigFile()    # Setting, reading file

print("Connected to : " + ser.portstr)
print("Ver. 1.00-11")
print("Wait 10s")
print("")

GPIO.output(GPIO_NETERROR, GPIO.HIGH)


# Wait 10 seconds to start
time.sleep(10)
GPIO.output(GPIO_NETERROR, GPIO.LOW)
# Clear Serial Buffer
ser.flushInput()

# Initialize Thread for check network
THRTIMER = 30   #30s timer
THRTIMERINI = 1     # 2s timer
tNetCheck = threading.Timer(THRTIMERINI, checkNetwork)
tNetCheck.start()

idN=""
chN=""
adcValue=0
maxVolt=0
maxVoltExp=0
calcVolt=0

# Start System Process
#while True:
fileData = ""
locRx = ""
errorFlag = False

# Import Service implementation class
# <rtc-template block="service_impl">
from elService_idl_example import *

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
elservicepro_spec = ["implementation_id", "elServicePro", 
		 "type_name",         "elServicePro", 
		 "description",       "ModuleDescription", 
		 "version",           "1.0.0", 
		 "vendor",            "VenderName", 
		 "category",          "Category", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

##
# @class elServicePro
# @brief ModuleDescription
# 
# 
class elServicePro(OpenRTM_aist.DataFlowComponentBase):
	
	##
	# @brief constructor
	# @param manager Maneger Object
	# 
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_elout = OpenRTM_aist.instantiateDataType(RTC.TimedCharSeq)
		"""
		"""
		self._eloutOut = OpenRTM_aist.OutPort("elout", self._d_elout)

		"""
		"""
		self._ElServicePort = OpenRTM_aist.CorbaPort("ElService")

		"""
		"""
		self._ElService = ElService_i()
		


		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	##
	#
	# The initialize action (on CREATED->ALIVE transition)
	# formaer rtc_init_entry() 
	# 
	# @return RTC::ReturnCode_t
	# 
	#
	def onInitialize(self):		
		# Set OutPort buffers
		self.addOutPort("elout",self._eloutOut)
		
		# Set service provider to Ports
		self._ElServicePort.registerProvider("ElService", "aqua::ElService", self._ElService)
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		self.addPort(self._ElServicePort)
		
		return RTC.RTC_OK
	
	###
	## 
	## The finalize action (on ALIVE->END transition)
	## formaer rtc_exiting_entry()
	## 
	## @return RTC::ReturnCode_t
	#
	## 
	#def onFinalize(self):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The startup action when ExecutionContext startup
	## former rtc_starting_entry()
	## 
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The shutdown action when ExecutionContext stop
	## former rtc_stopping_entry()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The activated action (Active state entry action)
	## former rtc_active_entry()
	##
	## @param ec_id target ExecutionContext Id
	## 
	## @return RTC::ReturnCode_t
	##
	##
	def onActivated(self, ec_id):
                print("activate")
		return RTC.RTC_OK
	
	###
	##
	## The deactivated action (Active state exit action)
	## former rtc_active_exit()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	def onDeactivated(self, ec_id):
                print("deactivate")
		return RTC.RTC_OK
	
	###
	##
	## The execution action that is invoked periodically
	## former rtc_active_do()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	def onExecute(self, ec_id):
               buf = self._ElService.getNumber()
	       print ("phone Number" , buf)
               print("plese in serial")
	       fileData = ""
	       locRx = ""
	       errorFlag = False
	       while (locRx != "Z"):
		    locRx = readSerialLine()
		    if(locRx != "Z"):
		        locStrRx = locRx.split(',')
		        chkComm = locStrRx[0][0]  #Get command
            		print("get comand"+chkComm)
			if((chkComm == "D") or (chkComm == "E")):
			    try:
                                idN = str(locStrRx[0])

                                chN = locStrRx[1]

                                adcValue = float.fromhex(locStrRx[2])

                                adcValue = float.fromhex(locStrRx[2])
                                digitalFlag = int(locStrRx[3], 16)

                                maxVolt = float.fromhex(locStrRx[4])
                                maxVoltExp = convToFloat8(locStrRx[5])

                                adjVolt = convToFloat16(locStrRx[6])
                                adjVoltExp = convToFloat8(locStrRx[7])

                                calcVolt = maxVolt * math.pow(10, maxVoltExp)
                                calcVolt = (adcValue * calcVolt) / 0xffff
                                calcVolt += adjVolt * math.pow(10, adjVoltExp)

                                # ch5
                                if int(chN) == 5:
                                    digitalFlag = 0
                                    calcVolt = (CH5_A * calcVolt) + CH5_B
		                # ch6
                                if int(chN) == 6:
                                    digitalFlag = 0
                                    calcVolt = (CH6_A * calcVolt) + CH6_B
		                # ch6
                                if int(chN) == 7:
                                    digitalFlag = 0
                                    calcVolt = (CH7_A * calcVolt) + CH7_B

                            except:
                                print ("Unknown serial data! Float or Hexa value!")

                            print ("ID=", idN)
                            print ("Channel=", chN)
                            print ("ADC=", adcValue)
                            print("maxVolt=", maxVolt)
                            print("maxVoltExp=", maxVoltExp)
                            print("adjVolt=", adjVolt)
                            print("adjVoltExp=", adjVoltExp)
                            print("Volt=", calcVolt)
                            print(locStrRx[0])
                            #    print("fihish!")
                            fileData += locStrRx[0] + ","   # ID
                            fileData += str(chN) + ","      # Channel

                            if digitalFlag == 0:
                                fileData += "ANA,"
                            elif digitalFlag == 1:
                                fileData += "DIG1,"
                            elif digitalFlag == 2:
                                fileData += "DIG2,"

                            fileData += str("{0:3.4f}".format(calcVolt))
                            fileData += ","

                            today = datetime.datetime.now()
                            fileData += str("{0:%Y-%m-%d,%H:%M:%S}".format(today))
                            fileData += "\n"

           
                            if(chkComm == "E"):
                                print("check alert")
                                # ONアラート
                                if ((digitalFlag == 1) and (adcValue >= ADTHRESHOLD)):
                                    ef = open(ERRORLOG, 'a')
                                    errorData = str("{0:%Y-%m-%d,%H:%M:%S}".format(today))
                                    errorData += " ch:" + chN
                                    if int(chN) == 3:
                                        errorData += " " + CH3STR
                                    elif int(chN) == 4:
                                        errorData += " " + CH4STR
                                    else:
                                        errorData += " etc"
                                    errorData += " alarm\r\n"
                                    ef.write(errorData)
                                    ef.close()
                                    print("ch:" + chN + " ON alert")
                        #add phone
                                    call = client.calls.create(
                                    to= buf,
                                    from_="+815031878204",
                                    url="http://ellighttracker2.appspot.com/twilio/voice.xml"
                                    )

                                    print(call.sid)


                               # OFFアラート
                                if ((digitalFlag == 2) and (adcValue < ADTHRESHOLD)):
                                   ef = open(ERRORLOG, 'a')
                                   errorData = str("{0:%Y-%m-%d,%H:%M:%S}".format(today))
                                   errorData += " ch:" + chN
                                   if int(chN) == 3:
                                       errorData += " " + CH3STR
                                   elif int(chN) == 4:
                                       errorData += " " + CH4STR
                                   else:
                                        errorData += " etc"
                                   errorData += " alarm\r\n"
                                   ef.write(errorData)
                                   ef.close()
                                   print("ch:" + chN + " OFF alert")

                    # errorFlag = True
                                   call = client.calls.create(
                                   to=buf,
                                   from_="+815031878204",
                                   url="http://ellighttracker2.appspot.com/twilio/voice2.xml"
                                    )
                                   print(call.sid)
                                print("")
                        elif(chkComm == "G"):
                            today = datetime.datetime.now()
                            strDate = str("{0:%Y/%m/%d,%H:%M:%S}".format(today))
                            strDate = "G" + strDate + "\r\n"
                            ser.write(strDate.encode())
                        elif(chkComm == "I"):
                          # ip address request
                            ipaddr = [(s.connect(('8.8.8.8', 80)), s.getsockname()[0], s.close()) for s in [socket.socket(socket.AF_INET, socket.SOCK_DGRAM)]][0][1]
                            ser.write("I".encode())
                            ser.write(ipaddr.encode())
                            ser.write("\r\n".encode())
                    else:
                        f = open(ADCTEMP, 'a')
                        f.write(fileData)
                        f.close()
                         #   print("else")
                        #print("filedata2:"+fileData)
                        #buf = self._ElService.getData()
                        #print ("data is %d" , buf)
                        #buf2 = self._ElService.getNumber()
                        #print ("number is %d" , buf2)
			self._d_elout.data = str(fileData)
			self._eloutOut.write()
                        return RTC.RTC_OK
                        #self._eldataOut.write() 
                #buf = self._ElService.getData()
		#print ("data is %d" , buf)

                #buf2 = self._ElService.getNumber()
	        #print ("number is %d" , buf2)

                #result = "threthnum:"+str(buf)+", phoneNumber:"+str(buf2)

                #print(result) 
                
                #self._d_elout.data = result
                #self._eloutOut.write()

		#return RTC.RTC_OK
	
	###
	##
	## The aborting action when main logic error occurred.
	## former rtc_aborting_entry()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The error action in ERROR state
	## former rtc_error_do()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The reset action that is invoked resetting
	## This is same but different the former rtc_init_entry()
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The state update action that is invoked after onExecute() action
	## no corresponding operation exists in OpenRTm-aist-0.2.0
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##

	##
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	###
	##
	## The action that is invoked when execution context's rate is changed
	## no corresponding operation exists in OpenRTm-aist-0.2.0
	##
	## @param ec_id target ExecutionContext Id
	##
	## @return RTC::ReturnCode_t
	##
	##
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	



def elServiceProInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=elservicepro_spec)
    manager.registerFactory(profile,
                            elServicePro,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    elServiceProInit(manager)

    # Create a component
    comp = manager.createComponent("elServicePro")

def main():
	mgr = OpenRTM_aist.Manager.init(sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager()

if __name__ == "__main__":
	main()

